Name:           perl-CGI-Prototype
Version:        0.9053
Release:        4%{?dist}
Summary:        Create a CGI application by subclassing
License:        GPL or Artistic
Group:          Development/Libraries
URL:            http://search.cpan.org/dist/CGI-Prototype/
Source0:        http://www.cpan.org/authors/id/M/ME/MERLYN/CGI-Prototype-%{version}.tar.gz
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch:      noarch
Requires:       perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))

# core
BuildRequires:  perl(ExtUtils::MakeMaker)
BuildRequires:  perl(Test::More)
# cpan
BuildRequires:  perl(Class::Prototyped)
BuildRequires:  perl(Template)
# test
BuildRequires:  perl(Test::Pod), perl(Test::Pod::Coverage)

# use base masks these...
Requires:       perl(Class::Prototyped)
Requires:       perl(Template)

%description
The core of every CGI application seems to be roughly the same:

*   Analyze the incoming parameters, cookies, and URLs to determine the state
of the application (let's call this "dispatch").  
* Based on the current state, analyze the incoming parameters to respond to 
any form submitted ("respond").  
*   From there, decide what response page should be generated, and produce it
("render").

CGI::Prototype creates a "Class::Prototyped" engine for doing all this, with 
the right amount of callback hooks to customize the process.  Because I'm 
biased toward Template Toolkit for rendering HTML, I've also integrated that 
as my rendering engine of choice. And, being a fan of clean MVC designs, the
classes become the controllers, and the templates become the views, with clean 
separation of responsibilities, and "CGI::Prototype" a sort of "archetypal" 
controller.


%prep
%setup -q -n CGI-Prototype-%{version}

# make rpmlint happy
perl -pi -e 's|^#! ?perl|#!/usr/bin/perl|' t/*.t t/cprove
chmod -c -x t/cprove

# Filter unwanted Provides:
cat << \EOF > %{name}-prov
#!/bin/sh
%{__perl_provides} $* |\
  sed -e '/perl(My::.*)/d'
EOF

%define __perl_provides %{_builddir}/CGI-Prototype-%{version}/%{name}-prov
chmod +x %{__perl_provides}

%build
%{__perl} Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
rm -rf %{buildroot}

make pure_install PERL_INSTALL_ROOT=%{buildroot}

find %{buildroot} -type f -name .packlist -exec rm -f {} \;
find %{buildroot} -depth -type d -exec rmdir {} 2>/dev/null \;

%{_fixperms} %{buildroot}/*

%check
# note the "skipped: CGI::Prototype::Mecha not found" is expected; this module
# is a runtime requirement of that module, resulting in a
# plugin-before-the-base-module sorta deal.
make test

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc Changes README TODO t/
%{perl_vendorlib}/*
%{_mandir}/man3/*

%changelog
* Thu May 03 2007 Chris Weyl <cweyl@alumni.drew.edu> 0.9053-4
- bump

* Mon Apr 30 2007 Chris Weyl <cweyl@alumni.drew.edu> 0.9053-3
- switch to filtering deps, rather than doing it manually

* Mon Apr 30 2007 Chris Weyl <cweyl@alumni.drew.edu> 0.9053-2
- include full test suite in %%doc
- disable autoprov -- with this small of a package it's easier than filtering

* Mon Apr 09 2007 Chris Weyl <cweyl@alumni.drew.edu> 0.9053-1
- Specfile autogenerated by cpanspec 1.70.
